
Friend Class Form1
    Inherits System.Windows.Forms.Form

    Private m As Threading.Mutex = New Threading.Mutex(False, "ThereminoStarAllMutex")
    Private Function AlreadyRunning() As Boolean
        If Not m.WaitOne(0, False) Then
            'MsgBox("Theremino_StartALL is already running", MsgBoxStyle.Information)
            Return True
        End If
        Return False
    End Function

    Private Sub Form_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        If AlreadyRunning() Then End
        Me.Text = AppTitleAndVersion()
        EventsAreEnabled = False
        Load_INI()
        ' ---------------------------------------------------------------- OPEN
        OpenAllThereminicApps()
        ' ---------------------------------------------------------------- INIT
        EventsAreEnabled = True
        Timer_1Hz.Interval = 1000
        Timer_1Hz.Enabled = True
        Timer_10Hz.Interval = 100
        Timer_10Hz.Enabled = True
        Refresh()
        Opacity = 1
    End Sub

    Private Sub Form_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        CloseAllOpenedProcesses()
        CloseProgram()
    End Sub

    Private Sub CloseProgram()
        Timer_1Hz.Stop()
        Timer_10Hz.Stop()
        Save_INI()
        End
    End Sub

    Private Sub Form_LocationChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.LocationChanged
        If Not EventsAreEnabled Then Exit Sub
        LimitFormPosition(Me)
    End Sub

    Private Sub btn_ShutDownEnable_ClickButtonArea(ByVal Sender As System.Object, ByVal e As System.EventArgs) Handles btn_ShutDownEnable.ClickButtonArea
        If Not EventsAreEnabled Then Exit Sub
        Save_INI()
    End Sub

    ' ==============================================================================================================
    '   TIMER 1 Hz
    ' ==============================================================================================================
    Private Sub Timer_1Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_1Hz.Tick
        If Not EventsAreEnabled Then Return
        ' -------------------------------------------------------- MUST BE CALLED EVERY SECOND
        TestCpuUsage(Nothing, PictureBox1)
    End Sub

    Private Sub Timer_10Hz_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer_10Hz.Tick
        TestShutDown()
    End Sub

    Private Sub TestShutDown()
        If MidMousePressed() Then
            CloseAllOpenedProcesses()
            If btn_ShutDownEnable.Checked Then
                Beep()
                ForceWindowsShutDownAndPowerOff()
            End If
            CloseProgram()
        End If
    End Sub

End Class